
//--------------------------------------------------------------------------------------------------
#include "shared.fxh"

//--------------------------------------------------------------------------------------------------
texture Texture0;

//--------------------------------------------------------------------------------------------------
sampler linear_sampler	= sampler_state
{
    Texture				= (Texture0);
    MipFilter			= LINEAR;
    MinFilter			= LINEAR;
    MagFilter			= LINEAR;
};

//--------------------------------------------------------------------------------------------------
// VertexShader I/O
//--------------------------------------------------------------------------------------------------
struct VS_INPUT
{
	float3 vPos						: POSITION;							///< object space position
};
struct VS_OUTPUT
{
	float4 vPos						: POSITION;							///< projection space position
	float3 vTexCoord				: TEXCOORD0;						///< texture coordinates
};

//--------------------------------------------------------------------------------------------------
VS_OUTPUT vsSkyBoxMain ( VS_INPUT i )
{
	// no translation info
	float4x4 matViewNoTrans =
    {
        g_mView[0], g_mView[1], g_mView[2],
        float4( 0.f, 0.f, 0.f, 1.f )
    };

	VS_OUTPUT o;

    o.vPos				= mul( float4( i.vPos, 1.0f ), mul( matViewNoTrans, g_mProjection ) );
    o.vTexCoord			= i.vPos;

	return o;
}
//--------------------------------------------------------------------------------------------------
float4 psSkyBoxMain( VS_OUTPUT i ) : COLOR0
{
    float4 color		= tex3D( linear_sampler, i.vTexCoord );
	return color;
}
//--------------------------------------------------------------------------------------------------
technique tec0
{
    pass P0
    {
        VertexShader	= compile vs_2_0 vsSkyBoxMain();
        PixelShader		= compile ps_2_0 psSkyBoxMain();
        
        ZEnable = false;
        ZWriteEnable = false;
        AlphaBlendEnable = false;
        AlphaTestEnable = false;
    }
}
//--------------------------------------------------------------------------------------------------